Attribute VB_Name = "FontDialog"
Option Explicit

'ChooseFont structure and function declarations

Private Type ChooseFont
   lStructSize As Long
   hwndOwner As Long        'caller's window handle
   hdc As Long              'printer DC/IC or NULL
   lpLogFont As Long        'ptr. to a LOGFONT struct
   iPointSize As Long       '10*size in points of sel.font
   flags As Long            'enum. type flags
   rgbColors As Long        'returned text color
   lCustData As Long        'data passed to hook fn.
   lpfnHook As Long         'ptr. to hook function
   lpTemplateName As String 'custom template name
   hInstance As Long        'instance handle of.EXE that
                            'contains cust. dlg. template
   lpszStyle As String      'return the style field here
                            'must be LF_FACESIZE or bigger
   nFontType As Integer     'same value reported to the
                            'EnumFonts call back with the
                            'extra FONTTYPE_bits added
   MISSING_ALIGNMENT As Integer
   nSizeMin As Long         'minimum pt size allowed &
   nSizeMax As Long         'max pt size allowed if
                            'CF_LIMITSIZE is used
End Type

Private Declare Function ChooseFont _
  Lib "comdlg32.dll" Alias "ChooseFontA" _
  (ByRef pChoosefont As ChooseFont) As Long
Private Declare Function GetDeviceCaps _
  Lib "gdi32" _
  (ByVal hdc As Long, _
   ByVal nIndex As Long) As Long
Declare Sub MemoryCopy _
  Lib "kernel32" Alias "RtlMoveMemory" _
  (ByRef lpDest As Any, _
   ByRef lpSource As Any, _
   ByVal dwBytes As Long)

' FONT STUFF
Global Const LF_FACESIZE = 32
Type LOGFONT
   lfHeight As Long
   lfWidth As Long
   lfEscapement As Long
   lfOrientation As Long
   lfWeight As Long
   lfItalic As Byte
   lfUnderline As Byte
   lfStrikeOut As Byte
   lfCharSet As Byte
   lfOutPrecision As Byte
   lfClipPrecision As Byte
   lfQuality As Byte
   lfPitchAndFamily As Byte
   lfFaceName(LF_FACESIZE) As Byte
End Type

Public Const CF_ANSIONLY = &H400&
Public Const CF_APPLY = &H200&
Public Const CF_EFFECTS = &H100&
Public Const CF_ENABLEHOOK = &H8&
Public Const CF_ENABLETEMPLATE = &H10&
Public Const CF_ENABLETEMPLATEHANDLE = &H20&
Public Const CF_FIXEDPITCHONLY = &H4000&
Public Const CF_FORCEFONTEXIST = &H10000
Public Const CF_INITTOLOGFONTSTRUCT = &H40&
Public Const CF_LIMITSIZE = &H2000&
Public Const CF_NOFACESEL = &H80000
Public Const CF_NOSCRIPTSEL = &H800000
Public Const CF_NOSIMULATIONS = &H1000&
Public Const CF_NOSIZESEL = &H200000
Public Const CF_NOSTYLESEL = &H100000
Public Const CF_NOVECTORFONTS = &H800&
Public Const CF_NOVERTFONTS = &H1000000
Public Const CF_OWNERDISPLAY = &H80
Public Const CF_PRINTERFONTS = &H2
Public Const CF_SCALABLEONLY = &H20000
Public Const CF_SCREENFONTS = &H1
Public Const CF_SCRIPTSONLY = CF_ANSIONLY
Public Const CF_SELECTSCRIPT = &H400000
Public Const CF_SHOWHELP = &H4&
Public Const CF_TTONLY = &H40000
Public Const CF_USESTYLE = &H80&
Public Const CF_WYSIWYG = &H8000
Public Const CF_BOTH = (CF_SCREENFONTS Or CF_PRINTERFONTS)
Public Const CF_NOOEMFONTS = CF_NOVECTORFONTS

Private Const SIMULATED_FONTTYPE = &H8000
Private Const PRINTER_FONTTYPE = &H4000
Private Const SCREEN_FONTTYPE = &H2000
Private Const BOLD_FONTTYPE = &H100
Private Const ITALIC_FONTTYPE = &H200
Private Const REGULAR_FONTTYPE = &H400

Private Const LOGPIXELSY = 90 'Logical pixels/inch in Y
Private Const WM_CHOOSEFONT_GETLOGFONT = _
              (&H400 + 1) 'WM_USER + 1

Public Function FontBox(ByRef f As Form, _
                        ByRef ffont As String, _
                        ByRef fsize As Long, _
                        ByRef fstyle As String, _
                        ByRef fcolor As OLE_COLOR, _
                        ByVal fflags As Long) As Boolean
  Dim a As ChooseFont
  Dim LF As LOGFONT
  Dim Address As Long
  Dim Memhandle As Long
  Dim FaceNameString As String
  Dim res As Long
  '
  LF.lfHeight = fsize / -(72 / _
                GetDeviceCaps(f.hdc, LOGPIXELSY))
  LF.lfWeight = IIf(InStr(fstyle, "b"), 700, 300)
  If InStr(fstyle, "i") Then LF.lfItalic = 1
  If InStr(fstyle, "s") Then LF.lfStrikeOut = 1
  If InStr(fstyle, "u") Then LF.lfUnderline = 1
  Call MemoryCopy(LF.lfFaceName(0), _
                  ByVal ffont, LF_FACESIZE)
  a.lpLogFont = VarPtr(LF)
  a.hdc = f.hdc
  a.lStructSize = Len(a)
  a.hwndOwner = f.hwnd
  'CF_SCREENFONTS Or CF_EFFECTS
  a.flags = fflags Or _
            CF_INITTOLOGFONTSTRUCT
  a.nFontType = SCREEN_FONTTYPE
  a.rgbColors = fcolor
  res = ChooseFont(a)
  'Convert to string from byte array
  FaceNameString = StrConv(LF.lfFaceName, vbUnicode)
  If res = 0 Then FontBox = False: Exit Function
  fsize = Abs(LF.lfHeight * _
             (72 / GetDeviceCaps(f.hdc, LOGPIXELSY)))
  ffont = Left(FaceNameString, _
            InStr(FaceNameString, Chr$(0)) - 1)
  fcolor = a.rgbColors
  fstyle = ""
  If LF.lfWeight >= 500 Then fstyle = fstyle & "b"
  If LF.lfItalic Then fstyle = fstyle & "i"
  If LF.lfStrikeOut Then fstyle = fstyle & "s"
  If LF.lfUnderline Then fstyle = fstyle & "u"
  FontBox = True
End Function


