Attribute VB_Name = "basOwnMsgBox"
Option Explicit
'
' Owner defined MessageBox
' (OMB_Konstanten)

'==== SystemIcon Konstanten

Public Enum IDI_CONST
  IDI_APPLICATION = 32512&
  IDI_HAND
  IDI_QUESTION
  IDI_EXCLAMATION
  IDI_ASTERIK
End Enum

'==== individuelle Konstanten

'Textcontrol
Public Enum OMB_TEXTCONTROL
  OMB_LABEL = False 'Label verwenden (Default)
  OMB_TEXTBOX = True 'TextBox verwenden
End Enum
'Ausrichtung LabelText
Public Enum OMB_ALIGNMENT
  OMB_LEFT    'linksbndig (Default)
  OMB_RIGHT   'rechtsbndig
  OMB_CENTER  'zentriert
End Enum
Public Enum OMB_FORMCLOSE
  OMB_ENABLECLOSE = True 'Close zulassen (Default)
  OMB_DISABLECLOSE = False 'Close disablen
End Enum

'==== allgemeine Konstanten
'==== (zum Groteil identisch mit VB)

'Buttons
Public Enum OMB_BUTTONS
  OMB_OK
  OMB_OKCANCEL
  OMB_ABORTRETRYIGNORE
  OMB_YESNOCANCEL
  OMB_YESNO
  OMB_RETRYCANCEL
End Enum
'Icon
Public Enum OMB_ICONID
  OMB_NOICON '(Default)
  OMB_ICONAPPLICATION
  OMB_ICONSTOP
  OMB_ICONQUESTION
  OMB_ICONEXCLAMATION
  OMB_ICONINFORMATION
End Enum
'RckgabeButton
Public Enum OMB_RESULT
  OMB_IDNONE 'Box mit [X] geschlossen
  OMB_IDOK
  OMB_IDCANCEL
  OMB_IDABORT
  OMB_IDRETRY
  OMB_IDIGNORE
  OMB_IDYES
  OMB_IDNO
End Enum

Public Function OMB_SysBtns(ByVal b As OMB_BUTTONS) As String
'liefert die System-Buttons
  If (b < OMB_OK Or b > OMB_RETRYCANCEL) Then b = OMB_OK
  Select Case (b)
    Case OMB_OK:
      OMB_SysBtns = "&OK"
    Case OMB_OKCANCEL:
      OMB_SysBtns = "&OK~&Abbrechen"
    Case OMB_ABORTRETRYIGNORE:
      OMB_SysBtns = "&Abbrechen~&Wiederholen~&Ignorieren"
    Case OMB_YESNOCANCEL:
      OMB_SysBtns = "&Ja~&Nein~&Abbrechen"
    Case OMB_YESNO:
      OMB_SysBtns = "&Ja~&Nein"
    Case OMB_RETRYCANCEL:
      OMB_SysBtns = "&Wiederholen~&Abbrechen"
  End Select
End Function

Public Function OMB_SysBtnID(ByVal b As OMB_BUTTONS, _
                             ByVal i As Long) As OMB_RESULT
'liefert die Button-ID des Buttins i
  OMB_SysBtnID = OMB_IDNONE
  Select Case (b)
    Case OMB_OK:
      OMB_SysBtnID = OMB_IDOK
    Case OMB_OKCANCEL:
      OMB_SysBtnID = IIf(i = 0, OMB_IDOK, OMB_IDCANCEL)
    Case OMB_ABORTRETRYIGNORE:
      Select Case (i)
        Case 0: OMB_SysBtnID = OMB_IDABORT
        Case 1: OMB_SysBtnID = OMB_IDRETRY
        Case 2: OMB_SysBtnID = OMB_IDIGNORE
      End Select
    Case OMB_YESNOCANCEL:
      Select Case (i)
        Case 0: OMB_SysBtnID = OMB_IDYES
        Case 1: OMB_SysBtnID = OMB_IDNO
        Case 2: OMB_SysBtnID = OMB_IDCANCEL
      End Select
    Case OMB_YESNO:
      OMB_SysBtnID = IIf(i = 0, OMB_IDYES, OMB_IDNO)
    Case OMB_RETRYCANCEL:
      OMB_SysBtnID = IIf(i = 0, OMB_IDRETRY, OMB_IDCANCEL)
  End Select
End Function

